website/categories/urls.py
from django.urls import path
from django.contrib.auth.decorators import login_required

# include views for rendering the output
from .views import edCategoryListView
from .views import edCategoryCreateView
from .views import edCategoryUpdateView
from .views import edCategoryDeleteView

app_name = 'categories'

urlpatterns = [
    path('category/', login_required(edCategoryListView.as_view()), name='view'),
    path('category/new/', login_required(edCategoryCreateView.as_view()), name='new'),
    path('category/<int:pk>', login_required(edCategoryUpdateView.as_view()), name='edit'),
    path('category/<int:pk>/delete/', login_required(edCategoryDeleteView.as_view()), name='delete'),
]

website/main/urls.py
from django.conf.urls import include, url
from django.contrib import admin

from django.contrib.staticfiles.urls import staticfiles_urlpatterns

from django.conf import settings
from django.conf.urls.static import static

#for favicon URL
from django.contrib.staticfiles.storage import staticfiles_storage
from django.views.generic.base import RedirectView

urlpatterns = [
    url(r'^admin/', admin.site.urls),
    url('', include('searching.urls')),
    url('', include('users.urls')),
    url(r'^accounts/', include('shops.urls')), #shops are available only under account
    url(r'^accounts/', include('shopsortiment.urls')), #shops sortiment is available only under account
    url(r'^accounts/', include('sortiment.urls')), #sortiment is available only under account
    url(r'^accounts/', include('categories.urls')), #categories are available only under account
    #url(r'^search/', include('haystack.urls')),
    url(
        r'^favicon.ico$',
        RedirectView.as_view(
            url=staticfiles_storage.url('favicon.ico'),
            permanent=False),
        name="favicon"
    ),
]

urlpatterns += staticfiles_urlpatterns()

if settings.DEBUG:
    urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

website/sortiment/urls.py
from django.urls import path
from django.contrib.auth.decorators import login_required

# include views for rendering the output
from .views import edSortimentListView
from .views import edSortimentCreateView
from .views import edSortimentUpdateView
from .views import edSortimentDeleteView

app_name = 'sortiment'

urlpatterns = [
    path('sortiment/', login_required(edSortimentListView.as_view()), name='view'),
    path('sortiment/new/', login_required(edSortimentCreateView.as_view()), name='new'),
    path('sortiment/<int:pk>', login_required(edSortimentUpdateView.as_view()), name='edit'),
    path('sortiment/<int:pk>/delete/', login_required(edSortimentDeleteView.as_view()), name='delete'),
]

website/categories/models.py
from django.db import models
from users.models import User

# Create your models here.
# ===================== Models ===================== #
# product categories classificator
class edCategory(models.Model):
    name = models.CharField("Category name", max_length=200)
    parent_category = models.ForeignKey('self', null=True, blank=True, on_delete=models.CASCADE)
    #technical fields
    owner = models.ForeignKey(
        User,
        on_delete=models.CASCADE,
        default=1,
    )
    added_date = models.DateTimeField("Date added", auto_now_add=True, null=True)
    modified_date = models.DateTimeField("Date last modified", auto_now=True, null=True)
    
    def __str__(self):
        return ('%s' % (self.name or ''))

website/categories/views.py
from django.shortcuts import render
from django.views import generic
from django.views.generic.edit import FormView, CreateView, UpdateView, DeleteView
from django.urls import reverse_lazy

# include main model for shops
from .models import edCategory

#####   Category Views
class edCategoryListView(generic.ListView):
    model = edCategory
    context_object_name = 'category'   # your own name for the list as a template variable
    template_name = 'categories/list.html'  # Specify your own template name/location

class edCategoryDetailView(generic.DetailView):
    model = edCategory   
    context_object_name = 'category'   # your own name for the list as a template variable
    template_name = 'categories/detail.html'  # Specify your own template name/location 

class edCategoryCreateView(CreateView):
    model = edCategory
    context_object_name = 'category'   # your own name for the list as a template variable
    template_name = 'categories/new.html'
    fields = ['name', 'parent_category']
    success_url = reverse_lazy('categories:view')
    def form_valid(self, form):
        form.instance.owner = self.request.user
        return super(edCategoryCreateView, self).form_valid(form)

class edCategoryUpdateView(UpdateView):
    model = edCategory
    template_name = 'categories/edit.html'
    context_object_name = 'category'   # your own name for the list as a template variable
    fields = ['name', 'parent_category']
    success_url = reverse_lazy('categories:view')

class edCategoryDeleteView(DeleteView):
    model = edCategory
    #template_name = 'stores/edCategory_confirm_delete.html'
    success_url = reverse_lazy('categories:view')    

website/templates/categories/edit.html
{% extends 'main/base_editform.html' %}

{% block content %}

<div class="page-header header-filter" data-parallax="true" style="background-image: url('{{ landing_top }}'); background-size: cover; background-position: top center;">
    <div class="container">
        <div class="row">
            <div class="col-md-6 ml-auto mr-auto">

            <!-- Edit form -->
            <form class="form" method="POST" enctype="multipart/form-data" action="{% url 'categories:edit' category.id %}">
                {% csrf_token %}
                <div class="card card-signup">
                    <h2 class="card-title text-center">{{ category.name }}</h2>
                    <div class="card-body">
                        <div class="row">
                            <div class="col-md-12 ml-auto mr-auto">
                                {% for hidden_field in form.hidden_fields %}
                                    {{ hidden_field }}
                                {% endfor %}

                                {% if form.non_field_errors %}
                                <div class="alert alert-danger" role="alert">
                                    {% for error in form.non_field_errors %}
                                    {{ error }}
                                    {% endfor %}
                                </div>
                                {% endif %}
                            </div>
                        </div>
                        <div class="row">
                            <div class="col-md-6 ml-auto mr-auto">
                                {% for field in form.visible_fields %}
                                    {% include "categories/form_field.html" with field=field %}
                                {% endfor %}
                            </div>
                        </div>
                        <div class="row">
                            <div class="col-md-10 ml-auto mr-auto">
                                <div class="card-footer justify-content-center">
                                    <button type="submit" class="btn btn-success btn-round">Saglabāt</button>
                                    <a href="{% url 'categories:view' %}" class="btn btn-default btn-round ml-3">Atcelt</a>
                                </div>
                                <input type="hidden" name="next" value="{{ next }}" />        
                            </div>
                        </div>

                    </div>
                    
                </div>
            </form>

{% if next %}
  {% if user.is_authenticated %}
    <p>Your account doesn't have access to this page. To proceed,
    please login with an account that has access.</p>
  {% else %}
    <p>Please login to see this page.</p>
  {% endif %}
{% endif %}
                
                </div>
        </div>
    </div>
</div>
  

{% endblock %}

website/templates/categories/form_field.html
{% load widget_tweaks %}
<div class="form-group bmd-form-group">
        {% if field.field.widget.input_type != "file" %}
        {{ field.label_tag }}
        {% endif %}

        {% if form.is_bound %}
            {% if field.errors %}
                {% render_field field class="form-control is-invalid" %}
                {% for error in field.errors %}
                <div class="invalid-feedback">
                    {{ error }}
                </div>
                {% endfor %}
            {% else %}
                {% render_field field class="form-control is-valid" %}
            {% endif %}
        {% else %}
            {% if field.field.widget.input_type == "select" %}
                {% render_field field class="selectpicker col-md-12 px-0" data-style="select-with-transition" %}
            {% else %}
                {% render_field field class="form-control" %}
            {% endif %}
        {% endif %}

        {% if field.help_text %}
            <small class="form-text text-muted">{{ field.help_text }}</small>
        {% endif %}
    </div>

website/templates/categories/list.html
{% extends 'main/base.html' %}

{% block content %}
  
    <div class="container">
        <div class="row">
            <div class="col-lg-8 col-md-10 ml-auto mr-auto">

                <div class="section">
                        <div class="container">
                            <h2 class="section-title">Produktu kategorijas</h2>

                            <div class="row">
                                {% if category %}
                                <div class="table-responsive">
                                <table class="table table-shopping">
                                    <thead>
                                    <tr>
                                        <th>Nosaukums</th>
                                        <th>Galvenā kategorija</th>
                                        <th class="text-right"></th>
                                    </tr>
                                    </thead>
                                    <tbody>
                                    {% for category in category %}
                                    <tr>
                                        <td>{{category.name|default_if_none:""}}</td>
                                        <td>{{category.parent_category|default_if_none:""}}</td>
                                        <td class="td-actions text-right">
                                                <form method="POST" action="{% url 'categories:delete' category.id %}">
                                                    {% csrf_token %}
                                                    <a href="{% url 'categories:edit' category.id %}">
                                                        <button type="button" rel="tooltip" class="btn btn-success btn-round btn-just-icon btn-sm" data-original-title="" title="">
                                                            <i class="material-icons">edit</i>
                                                        </button>
                                                    </a>
                                                    <a href="{% url 'categories:delete' category.id %}">
                                                    <button type="submit" rel="tooltip" class="btn btn-danger btn-round btn-just-icon btn-sm" data-original-title="" title="" onClick="return confirm('Vai tiešām vēlaties dzēst?');">
                                                        <i class="material-icons">close</i>
                                                    </button>
                                                    </a>
                                                </form>
                                            </td>
                                        </tr>
                                    {% endfor %}
                                    </tbody>
                                </table>
                                <p>
                                    <a href="{% url 'categories:new' %}" class="btn btn-success btn-round btn-just-icon btn-md">
                                        <i class="material-icons">add</i>
                                    </a>
                                </p>
                                </div>
                                {% else %}
                                <p> 
                                    <a href="{% url 'categories:new' %}" class="btn btn-success btn-round btn-just-icon btn-md">
                                        <i class="material-icons">add</i>
                                    </a>
                                    Nav kategoriju. Pievienot jaunu.
                                </p>
                                {% endif %}  
                            </div>
                    
                        </div>
                    </div>    
            
                </div>
        </div>
    </div>

  

{% endblock %}

website/templates/categories/new.html
{% extends 'main/base_editform.html' %}

{% block content %}

<div class="page-header header-filter" data-parallax="true" style="background-image: url('{{ landing_top }}'); background-size: cover; background-position: top center;">
    <div class="container">
        <div class="row">
            <div class="col-md-6 ml-auto mr-auto">

                <!-- Edit form -->
    <form class="form" method="POST" enctype="multipart/form-data" action="{% url 'categories:new' %}">
        {% csrf_token %}
        <div class="card card-signup">
            <h2 class="card-title text-center">Pievienot kategoriju</h2>
            <div class="card-body">
                <div class="row">
                    <div class="col-md-12 ml-auto mr-auto">
                        {% for hidden_field in form.hidden_fields %}
                            {{ hidden_field }}
                        {% endfor %}

                        {% if form.non_field_errors %}
                        <div class="alert alert-danger" role="alert">
                            {% for error in form.non_field_errors %}
                            {{ error }}
                            {% endfor %}
                        </div>
                        {% endif %}
                    </div>
                </div>
                <div class="row">
                    <div class="col-md-6 ml-auto mr-auto">
                        {% for field in form.visible_fields %}
                            {% include "main/form_field.html" with field=field %}
                        {% endfor %}
                    </div>
                </div>
                <div class="row">
                    <div class="col-md-10 ml-auto mr-auto">
                        <div class="card-footer justify-content-center">
                            <button type="submit" class="btn btn-success btn-round">Saglabāt</button>
                            <a href="{% url 'sortiment:view' %}" class="btn btn-default btn-round ml-3">Atcelt</a>
                        </div>
                        <input type="hidden" name="next" value="{{ next }}" />        
                    </div>
                </div>

            </div>
            
        </div>
            </form>

{% if next %}
  {% if user.is_authenticated %}
    <p>Your account doesn't have access to this page. To proceed,
    please login with an account that has access.</p>
  {% else %}
    <p>Please login to see this page.</p>
  {% endif %}
{% endif %}
                
                </div>
        </div>
    </div>
</div>
  

{% endblock %}